//+----------------------------------------------------------------------------+
//|                                                          i-Sadukey_v1.mq4  |
//+----------------------------------------------------------------------------+
#property copyright "*" 
#property link "*" 

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    NormalizedDigits = 5;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;

//
//
//
//
//

double UpH[];
double DnH[];
double Buffer1[]; 
double Buffer2[]; 
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(5);
      SetIndexBuffer(0,UpH);    SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH);    SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,Buffer1); 
      SetIndexBuffer(3,Buffer2); 
      SetIndexBuffer(4,trend);
      
         //
         //
         //
         //
         //
         
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
 
         //
         //
         //
         //
         //
         
   IndicatorShortName(timeFrameToString(timeFrame)+"  i_Sadukey ");
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { UpH[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for(int i=limit; i>=0; i--)
     {
        double value1 = 
          0.11859648*((Open[i+0]+Close[i+0]+High[i+0]+Low[i+0])/4 +Close[i+0])/2
         +0.11781324*((Open[i+1]+Close[i+1]+High[i+1]+Low[i+1])/4 +Close[i+1])/2
         +0.11548308*((Open[i+2]+Close[i+2]+High[i+2]+Low[i+2])/4 +Close[i+2])/2
         +0.11166411*((Open[i+3]+Close[i+3]+High[i+3]+Low[i+3])/4 +Close[i+3])/2
         +0.10645106*((Open[i+4]+Close[i+4]+High[i+4]+Low[i+4])/4 +Close[i+4])/2
         +0.09997253*((Open[i+5]+Close[i+5]+High[i+5]+Low[i+5])/4 +Close[i+5])/2
         +0.09238688*((Open[i+6]+Close[i+6]+High[i+6]+Low[i+6])/4 +Close[i+6])/2
         +0.08387751*((Open[i+7]+Close[i+7]+High[i+7]+Low[i+7])/4 +Close[i+7])/2
         +0.07464713*((Open[i+8]+Close[i+8]+High[i+8]+Low[i+8])/4 +Close[i+8])/2
         +0.06491178*((Open[i+9]+Close[i+9]+High[i+9]+Low[i+9])/4 +Close[i+9])/2
         +0.05489443*((Open[i+10]+Close[i+10]+High[i+10]+Low[i+10])/4 +Close[i+10])/2
         +0.04481833*((Open[i+11]+Close[i+11]+High[i+11]+Low[i+11])/4 +Close[i+11])/2
         +0.03490071*((Open[i+12]+Close[i+12]+High[i+12]+Low[i+12])/4 +Close[i+12])/2
         +0.02534672*((Open[i+13]+Close[i+13]+High[i+13]+Low[i+13])/4 +Close[i+13])/2
         +0.01634375*((Open[i+14]+Close[i+14]+High[i+14]+Low[i+14])/4 +Close[i+14])/2
         +0.00805678*((Open[i+15]+Close[i+15]+High[i+15]+Low[i+15])/4 +Close[i+15])/2
         +0.00062421*((Open[i+16]+Close[i+16]+High[i+16]+Low[i+16])/4 +Close[i+16])/2
         -0.00584512*((Open[i+17]+Close[i+17]+High[i+17]+Low[i+17])/4 +Close[i+17])/2
         -0.01127391*((Open[i+18]+Close[i+18]+High[i+18]+Low[i+18])/4 +Close[i+18])/2
         -0.01561738*((Open[i+19]+Close[i+19]+High[i+19]+Low[i+19])/4 +Close[i+19])/2
         -0.01886307*((Open[i+20]+Close[i+20]+High[i+20]+Low[i+20])/4 +Close[i+20])/2
         -0.02102974*((Open[i+21]+Close[i+21]+High[i+21]+Low[i+21])/4 +Close[i+21])/2
         -0.02216516*((Open[i+22]+Close[i+22]+High[i+22]+Low[i+22])/4 +Close[i+22])/2
         -0.02234315*((Open[i+23]+Close[i+23]+High[i+23]+Low[i+23])/4 +Close[i+23])/2
         -0.02165992*((Open[i+24]+Close[i+24]+High[i+24]+Low[i+24])/4 +Close[i+24])/2
         -0.02022973*((Open[i+25]+Close[i+25]+High[i+25]+Low[i+25])/4 +Close[i+25])/2
         -0.01818026*((Open[i+26]+Close[i+26]+High[i+26]+Low[i+26])/4 +Close[i+26])/2
         -0.01564777*((Open[i+27]+Close[i+27]+High[i+27]+Low[i+27])/4 +Close[i+27])/2
         -0.01277219*((Open[i+28]+Close[i+28]+High[i+28]+Low[i+28])/4 +Close[i+28])/2
         -0.00969230*((Open[i+29]+Close[i+29]+High[i+29]+Low[i+29])/4 +Close[i+29])/2
         -0.00654127*((Open[i+30]+Close[i+30]+High[i+30]+Low[i+30])/4 +Close[i+30])/2
         -0.00344276*((Open[i+31]+Close[i+31]+High[i+31]+Low[i+31])/4 +Close[i+31])/2
         -0.00050728*((Open[i+32]+Close[i+32]+High[i+32]+Low[i+32])/4 +Close[i+32])/2
         +0.00217042*((Open[i+33]+Close[i+33]+High[i+33]+Low[i+33])/4 +Close[i+33])/2
         +0.00451354*((Open[i+34]+Close[i+34]+High[i+34]+Low[i+34])/4 +Close[i+34])/2
         +0.00646441*((Open[i+35]+Close[i+35]+High[i+35]+Low[i+35])/4 +Close[i+35])/2
         +0.00798513*((Open[i+36]+Close[i+36]+High[i+36]+Low[i+36])/4 +Close[i+36])/2
         +0.00905725*((Open[i+37]+Close[i+37]+High[i+37]+Low[i+37])/4 +Close[i+37])/2
         +0.00968091*((Open[i+38]+Close[i+38]+High[i+38]+Low[i+38])/4 +Close[i+38])/2
         +0.00987326*((Open[i+39]+Close[i+39]+High[i+39]+Low[i+39])/4 +Close[i+39])/2
         +0.00966639*((Open[i+40]+Close[i+40]+High[i+40]+Low[i+40])/4 +Close[i+40])/2
         +0.00910488*((Open[i+41]+Close[i+41]+High[i+41]+Low[i+41])/4 +Close[i+41])/2
         +0.00824306*((Open[i+42]+Close[i+42]+High[i+42]+Low[i+42])/4 +Close[i+42])/2
         +0.00714199*((Open[i+43]+Close[i+43]+High[i+43]+Low[i+43])/4 +Close[i+43])/2
         +0.00586655*((Open[i+44]+Close[i+44]+High[i+44]+Low[i+44])/4 +Close[i+44])/2
         +0.00448255*((Open[i+45]+Close[i+45]+High[i+45]+Low[i+45])/4 +Close[i+45])/2
         +0.00305396*((Open[i+46]+Close[i+46]+High[i+46]+Low[i+46])/4 +Close[i+46])/2
         +0.00164061*((Open[i+47]+Close[i+47]+High[i+47]+Low[i+47])/4 +Close[i+47])/2
         +0.00029596*((Open[i+48]+Close[i+48]+High[i+48]+Low[i+48])/4 +Close[i+48])/2
         -0.00093445*((Open[i+49]+Close[i+49]+High[i+49]+Low[i+49])/4 +Close[i+49])/2
         -0.00201426*((Open[i+50]+Close[i+50]+High[i+50]+Low[i+50])/4 +Close[i+50])/2
         -0.00291701*((Open[i+51]+Close[i+51]+High[i+51]+Low[i+51])/4 +Close[i+51])/2
         -0.00362661*((Open[i+52]+Close[i+52]+High[i+52]+Low[i+52])/4 +Close[i+52])/2
         -0.00413703*((Open[i+53]+Close[i+53]+High[i+53]+Low[i+53])/4 +Close[i+53])/2
         -0.00445206*((Open[i+54]+Close[i+54]+High[i+54]+Low[i+54])/4 +Close[i+54])/2
         -0.00458437*((Open[i+55]+Close[i+55]+High[i+55]+Low[i+55])/4 +Close[i+55])/2
         -0.00455457*((Open[i+56]+Close[i+56]+High[i+56]+Low[i+56])/4 +Close[i+56])/2
         -0.00439006*((Open[i+57]+Close[i+57]+High[i+57]+Low[i+57])/4 +Close[i+57])/2
         -0.00412379*((Open[i+58]+Close[i+58]+High[i+58]+Low[i+58])/4 +Close[i+58])/2
         -0.00379323*((Open[i+59]+Close[i+59]+High[i+59]+Low[i+59])/4 +Close[i+59])/2
         -0.00343966*((Open[i+60]+Close[i+60]+High[i+60]+Low[i+60])/4 +Close[i+60])/2
         -0.00310850*((Open[i+61]+Close[i+61]+High[i+61]+Low[i+61])/4 +Close[i+61])/2
         -0.00285188*((Open[i+62]+Close[i+62]+High[i+62]+Low[i+62])/4 +Close[i+62])/2
         -0.00273508*((Open[i+63]+Close[i+63]+High[i+63]+Low[i+63])/4 +Close[i+63])/2
         -0.00274361*((Open[i+64]+Close[i+64]+High[i+64]+Low[i+64])/4 +Close[i+64])/2
         +0.01018757*((Open[i+65]+Close[i+65]+High[i+65]+Low[i+65])/4 +Close[i+65])/2;

        double value2= 
          0.11859648*(((Open[i+0]+Close[i+0]+High[i+0]+Low[i+0])/4 +Open[i+0])/2)
         +0.11781324*(((Open[i+1]+Close[i+1]+High[i+1]+Low[i+1])/4 +Open[i+1])/2)
         +0.11548308*(((Open[i+2]+Close[i+2]+High[i+2]+Low[i+2])/4 +Open[i+2])/2)
         +0.11166411*(((Open[i+3]+Close[i+3]+High[i+3]+Low[i+3])/4 +Open[i+3])/2)
         +0.10645106*(((Open[i+4]+Close[i+4]+High[i+4]+Low[i+4])/4 +Open[i+4])/2)
         +0.09997253*(((Open[i+5]+Close[i+5]+High[i+5]+Low[i+5])/4 +Open[i+5])/2)
         +0.09238688*(((Open[i+6]+Close[i+6]+High[i+6]+Low[i+6])/4 +Open[i+6])/2)
         +0.08387751*(((Open[i+7]+Close[i+7]+High[i+7]+Low[i+7])/4 +Open[i+7])/2)
         +0.07464713*(((Open[i+8]+Close[i+8]+High[i+8]+Low[i+8])/4 +Open[i+8])/2)
         +0.06491178*(((Open[i+9]+Close[i+9]+High[i+9]+Low[i+9])/4 +Open[i+9])/2)
         +0.05489443*(((Open[i+10]+Close[i+10]+High[i+10]+Low[i+10])/4 +Open[i+10])/2)
         +0.04481833*(((Open[i+11]+Close[i+11]+High[i+11]+Low[i+11])/4 +Open[i+11])/2)
         +0.03490071*(((Open[i+12]+Close[i+12]+High[i+12]+Low[i+12])/4 +Open[i+12])/2)
         +0.02534672*(((Open[i+13]+Close[i+13]+High[i+13]+Low[i+13])/4 +Open[i+13])/2)
         +0.01634375*(((Open[i+14]+Close[i+14]+High[i+14]+Low[i+14])/4 +Open[i+14])/2)
         +0.00805678*(((Open[i+15]+Close[i+15]+High[i+15]+Low[i+15])/4 +Open[i+15])/2)
         +0.00062421*(((Open[i+16]+Close[i+16]+High[i+16]+Low[i+16])/4 +Open[i+16])/2)
         -0.00584512*(((Open[i+17]+Close[i+17]+High[i+17]+Low[i+17])/4 +Open[i+17])/2)
         -0.01127391*(((Open[i+18]+Close[i+18]+High[i+18]+Low[i+18])/4 +Open[i+18])/2)
         -0.01561738*(((Open[i+19]+Close[i+19]+High[i+19]+Low[i+19])/4 +Open[i+19])/2)
         -0.01886307*(((Open[i+20]+Close[i+20]+High[i+20]+Low[i+20])/4 +Open[i+20])/2)
         -0.02102974*(((Open[i+21]+Close[i+21]+High[i+21]+Low[i+21])/4 +Open[i+21])/2)
         -0.02216516*(((Open[i+22]+Close[i+22]+High[i+22]+Low[i+22])/4 +Open[i+22])/2)
         -0.02234315*(((Open[i+23]+Close[i+23]+High[i+23]+Low[i+23])/4 +Open[i+23])/2)
         -0.02165992*(((Open[i+24]+Close[i+24]+High[i+24]+Low[i+24])/4 +Open[i+24])/2)
         -0.02022973*(((Open[i+25]+Close[i+25]+High[i+25]+Low[i+25])/4 +Open[i+25])/2)
         -0.01818026*(((Open[i+26]+Close[i+26]+High[i+26]+Low[i+26])/4 +Open[i+26])/2)
         -0.01564777*(((Open[i+27]+Close[i+27]+High[i+27]+Low[i+27])/4 +Open[i+27])/2)
         -0.01277219*(((Open[i+28]+Close[i+28]+High[i+28]+Low[i+28])/4 +Open[i+28])/2)
         -0.00969230*(((Open[i+29]+Close[i+29]+High[i+29]+Low[i+29])/4 +Open[i+29])/2)
         -0.00654127*(((Open[i+30]+Close[i+30]+High[i+30]+Low[i+30])/4 +Open[i+30])/2)
         -0.00344276*(((Open[i+31]+Close[i+31]+High[i+31]+Low[i+31])/4 +Open[i+31])/2)
         -0.00050728*(((Open[i+32]+Close[i+32]+High[i+32]+Low[i+32])/4 +Open[i+32])/2)
         +0.00217042*(((Open[i+33]+Close[i+33]+High[i+33]+Low[i+33])/4 +Open[i+33])/2)
         +0.00451354*(((Open[i+34]+Close[i+34]+High[i+34]+Low[i+34])/4 +Open[i+34])/2)
         +0.00646441*(((Open[i+35]+Close[i+35]+High[i+35]+Low[i+35])/4 +Open[i+35])/2)
         +0.00798513*(((Open[i+36]+Close[i+36]+High[i+36]+Low[i+36])/4 +Open[i+36])/2)
         +0.00905725*(((Open[i+37]+Close[i+37]+High[i+37]+Low[i+37])/4 +Open[i+37])/2)
         +0.00968091*(((Open[i+38]+Close[i+38]+High[i+38]+Low[i+38])/4 +Open[i+38])/2)
         +0.00987326*(((Open[i+39]+Close[i+39]+High[i+39]+Low[i+39])/4 +Open[i+39])/2)
         +0.00966639*(((Open[i+40]+Close[i+40]+High[i+40]+Low[i+40])/4 +Open[i+40])/2)
         +0.00910488*(((Open[i+41]+Close[i+41]+High[i+41]+Low[i+41])/4 +Open[i+41])/2)
         +0.00824306*(((Open[i+42]+Close[i+42]+High[i+42]+Low[i+42])/4 +Open[i+42])/2)
         +0.00714199*(((Open[i+43]+Close[i+43]+High[i+43]+Low[i+43])/4 +Open[i+43])/2)
         +0.00586655*(((Open[i+44]+Close[i+44]+High[i+44]+Low[i+44])/4 +Open[i+44])/2)
         +0.00448255*(((Open[i+45]+Close[i+45]+High[i+45]+Low[i+45])/4 +Open[i+45])/2)
         +0.00305396*(((Open[i+46]+Close[i+46]+High[i+46]+Low[i+46])/4 +Open[i+46])/2)
         +0.00164061*(((Open[i+47]+Close[i+47]+High[i+47]+Low[i+47])/4 +Open[i+47])/2)
         +0.00029596*(((Open[i+48]+Close[i+48]+High[i+48]+Low[i+48])/4 +Open[i+48])/2)
         -0.00093445*(((Open[i+49]+Close[i+49]+High[i+49]+Low[i+49])/4 +Open[i+49])/2)
         -0.00201426*(((Open[i+50]+Close[i+50]+High[i+50]+Low[i+50])/4 +Open[i+50])/2)
         -0.00291701*(((Open[i+51]+Close[i+51]+High[i+51]+Low[i+51])/4 +Open[i+51])/2)
         -0.00362661*(((Open[i+52]+Close[i+52]+High[i+52]+Low[i+52])/4 +Open[i+52])/2)
         -0.00413703*(((Open[i+53]+Close[i+53]+High[i+53]+Low[i+53])/4 +Open[i+53])/2)
         -0.00445206*(((Open[i+54]+Close[i+54]+High[i+54]+Low[i+54])/4 +Open[i+54])/2)
         -0.00458437*(((Open[i+55]+Close[i+55]+High[i+55]+Low[i+55])/4 +Open[i+55])/2)
         -0.00455457*(((Open[i+56]+Close[i+56]+High[i+56]+Low[i+56])/4 +Open[i+56])/2)
         -0.00439006*(((Open[i+57]+Close[i+57]+High[i+57]+Low[i+57])/4 +Open[i+57])/2)
         -0.00412379*(((Open[i+58]+Close[i+58]+High[i+58]+Low[i+58])/4 +Open[i+58])/2)
         -0.00379323*(((Open[i+59]+Close[i+59]+High[i+59]+Low[i+59])/4 +Open[i+59])/2)
         -0.00343966*(((Open[i+60]+Close[i+60]+High[i+60]+Low[i+60])/4 +Open[i+60])/2)
         -0.00310850*(((Open[i+61]+Close[i+61]+High[i+61]+Low[i+61])/4 +Open[i+61])/2)
         -0.00285188*(((Open[i+62]+Close[i+62]+High[i+62]+Low[i+62])/4 +Open[i+62])/2)
         -0.00273508*(((Open[i+63]+Close[i+63]+High[i+63]+Low[i+63])/4 +Open[i+63])/2)
         -0.00274361*(((Open[i+64]+Close[i+64]+High[i+64]+Low[i+64])/4 +Open[i+64])/2)
         +0.01018757*(((Open[i+65]+Close[i+65]+High[i+65]+Low[i+65])/4 +Open[i+65])/2);

         UpH[i]   = EMPTY_VALUE;
         DnH[i]   = EMPTY_VALUE;
         trend[i] = trend[i+1]; 
         Buffer1[i]= NormalizeDouble(value1,NormalizedDigits);
         Buffer2[i]= NormalizeDouble(value2,NormalizedDigits);
         if (Buffer1[i]>Buffer2[i]) trend[i] =  1;
         if (Buffer1[i]<Buffer2[i]) trend[i] = -1;
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;
      }
      manageAlerts();
      return(0);
   }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NormalizedDigits,4,y);
            UpH[i] = EMPTY_VALUE;
            DnH[i] = EMPTY_VALUE;
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;
   }
   manageAlerts();  
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"UP");
         if (trend[whichBar] == -1) doAlert(whichBar,"DOWN");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

//       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" sadukey trend changed to "+doWhat;
         message =  Symbol()+" "+ TFToStr(Period())+" Sadukey trend "+doWhat; 
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" sadukey ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


//+------------------------------------------------------------------+                                                                          //
string TFToStr(int tf)   {                                                                                                                      //
//+------------------------------------------------------------------+                                                                          //
  if (tf == 0)        tf = Period();                                                                                                            //
  if (tf >= 43200)    return("MN");                                                                                                             //
  if (tf >= 10080)    return("W1");                                                                                                             //
  if (tf >=  1440)    return("D1");                                                                                                             //
  if (tf >=   240)    return("H4");                                                                                                             //
  if (tf >=    60)    return("H1");                                                                                                             //
  if (tf >=    30)    return("M30");                                                                                                            //
  if (tf >=    15)    return("M15");                                                                                                            //
  if (tf >=     5)    return("M5");                                                                                                             //
  if (tf >=     1)    return("M1");                                                                                                             //
  return("");                                                                                                                                   //
}                                                                                                                                               //
// ============================================================================================================================================ //